import java.util.*;
import java.util.Date;
import java.text.SimpleDateFormat;

public class Appointment {

	private MyDate f_date;
	private ArrayList<MyDate> t_date;
	private static Check check;

	public Appointment(ArrayList<MyDate> table_date, Check c) {
		this.check = c;

		this.t_date = table_date;
	}

	/**
	 * Get the final date
	 * @return MyDate, the final date
	 */
	public MyDate get_f_date() {
		return this.f_date;
	}

	/**
	 * Set the best date
	 */
	public void most_popular_date() {
		int c = 0;
		int tmp = 0;

		// Compare each date with each other in the table
		for (MyDate date1 : this.t_date) {

			for (MyDate date2 : this.t_date) {
				if (date1.get_date().equals(date2.get_date()))
					c++;
			}
			// if date's most popular
			if (c >= tmp) {
				tmp = c;
				this.f_date = date1;
			}
			// reset
			c = -1;
		}

		this.right_period();
	}

	/**
	 * Get the right meeting's hour
	 */
	private void right_period() {
		Time t_min = new Time(0, 0);
		Time t_max = new Time(0, 0);

		for (MyDate d : this.t_date) {
			if (d.equals(f_date)) {

				if (!this.check.is_before(d.get_t_from(), t_min)) {
					t_min = d.get_t_from();
					t_max = d.get_t_to();
				}
			}
		}

		this.f_date.set_t_from(t_min);
		this.f_date.set_t_to(t_max);
	}
}
