import java.util.Date;
import java.text.SimpleDateFormat;
import java.net.*;

public class Check {
	private static Output output;
	private static SimpleDateFormat parseDate = new SimpleDateFormat("dd/MM/yyyy");

	public Check(Output out) {
    this.output = out;
	}

  /**
   * Exit the program if no internet connection
   */
  public void check_connection(){

		try
		{
			URL url = new URL("http://www.google.com");
			URLConnection connection = url.openConnection();
			connection.connect();

		}catch (Exception e){

			output.print("Pour utiliser cetter application veuillez vous connecter à internet");
			output.print("Exit...", "red");
			System.exit(0);
		}
  }

	/**
	* Check the coordinate validity
	* @param  pos       [description]
	* @param  range     [description]
	* @return           [description]
	*/
	public Boolean pos_validity(String pos, float range){
		float r = 0;
		try{
			r = Float.parseFloat(pos);
		} catch(Exception e) {
			output.error("Veuillez entrer un nombre à virgule valide");
			return false;
		}

		if(r < range && r > -range){
			return true;
		}else{
			output.error("La coordonnée doit être entre " + -range + " et " + range);
			return false;
		}
	}

	/**
	 * Check MyDate format validity
	 * @param  d [description]
	 * @return   [description]
	 */
	public Boolean myDate_validity(String[] d){
		if(d.length == 3){

			if(!date_validity(d[0]))
				return false;
			if(!hour_validity(d[1]))
				return false;
			if(!hour_validity(d[2]))
				return false;

			if(!is_before(d[1], d[2]))
				return false;

		}else{
			output.error("La date doit correspondre à la structure indiquée");
			return false;
		}
		return true;
	}

	/**
	 * [date_validity description]
	 * @param  d1 [description]
	 * @return    [description]
	 */
	public Boolean date_validity(String d1){
		Date d2 = new Date(); // this object contains the current date value

		//check date's format
		try {
			Date parse_d = parseDate.parse(d1);

			if(d2.after(parse_d)){
				output.error("La date doit être postérieur à la date d'aujourd'hui.");
				return false;
			}
		} catch (Exception e) {
			output.error("La date '" + d1 + "' ne correspond pas au pattern, " +
			parseDate.toPattern() + ", demandé.");
			return false;
		}


		return true;
	}

	/**
	 * [hour_validity description]
	 * @param  t [description]
	 * @return   [description]
	 */
	public Boolean hour_validity(String t){
		String[] temp;
		temp = t.split(":");
		if(temp.length != 2){
			output.error(new String[]{"Le format des heures entrée ne correpsond pas à celui demandé",
									"L'heure doit être séparée pas un :"});
			return false;
		}

		int p1 = Integer.parseInt(temp[0]);
		int p2 = Integer.parseInt(temp[1]);

		if(p1 > 24 || p1 < 0 || p2 < 0 || p2 > 60){
			output.error("L'heure n'est pas correcte");
			return false;
		}

		return true;
	}


	/**
	 *
	 * @param t1
	 * @param t2
	 * @return
	 */
	public Boolean is_before(Time t1, Time t2){

		if(t1.get_hour() > t2.get_hour()){
			return false;
		}else if(t1.get_hour() == t2.get_min()){

			if(t1.get_min() >= t2.get_min()){
				return false;
			}else{
				return true;
			}
		}else{
			return true;
		}
	}

	/**
	 * True if t1 previous t2
	 * @param  t1 [description]
	 * @param  t2 [description]
	 * @return    [description]
	 */
	public Boolean is_before(String t1, String t2){
		String[] temp1 = t1.split(":");
		String[] temp2 = t2.split(":");

		if(Integer.parseInt(temp1[0]) > Integer.parseInt(temp2[0])){
			output.error("La première heure entrée doit précéder la seconde.");
			return false;
		}else if(Integer.parseInt(temp1[0]) == Integer.parseInt(temp2[0])){

			if(Integer.parseInt(temp1[1]) >= Integer.parseInt(temp2[1])){
				output.error("La première heure entrée doit précéder la seconde.");
				return false;
			}else{
				return true;
			}
		}else{
			return true;
		}
	}

}
