import java.util.*;

public class City {

	private Location geo_center;
	private String city;
	private ArrayList<Location> t_loc;

	private Boolean library = false;
	private Boolean university = false;

	private Output output;

	public City(ArrayList<Location> table_loc, Output out) {
    this.output = out;
		this.t_loc = table_loc;
	}

	/**
	 * Get geographical center point
	 *
	 * @return Location, position x and y
	 */
	public Location get_geo_center() {
		return this.geo_center;
	}

	/**
	 * Get city name
	 *
	 * @return String, city name
	 */
	public String get_city() {
		if(this.city.isEmpty())
			return "";
		else
			return this.city;
	}

	public void set_city(String city){
		this.city = city;
	}

	public void set_lib(Boolean b) {
		this.library = b;
	}

	public void set_uni(Boolean b) {
		this.university = b;
	}

	/**
	 * Pint all location
	 */
	public void show_locs() {
		this.t_loc.forEach((l) -> System.out.println("x: " + l.get_x() + ", y: " + l.get_y()));
	}

	/**
	 * Print all city parameters state
	 */
	public void show_params() {
		output.section("Paramètres de la ville:");
		output.print("Bibliothèque:   " + this.library);
		output.printN("Université:     " + this.university);
	}

	/**
	 * Calcul the geographic center of the table points
	 */
	public void calcul_geo_center() {
		Location c = new Location(0, 0);
		float x = 0;
		float y = 0;

		for (Location l : this.t_loc) {
			x += l.get_x();
			y += l.get_y();
		}

		c.set_x(x / this.t_loc.size());
		c.set_y(y / this.t_loc.size());

		this.geo_center = c;
	}

}
