import java.util.Scanner;

public class Input {

  private String buffer;
  private Scanner sc = new Scanner(System.in);
  private static Output output;

  public Input(Output out) {
    this.output = out;
  }

  /**
   * Get local buffer
   * @return local buffer
   */
  public String get_value(){
    return this.buffer;
  }

  /**
   * Read the next line and save it into local buffer
   * @return local buffer
   */
  public String nextLine(){
    output.change_color("cyan");
    this.buffer = this.sc.nextLine();
    output.change_color("reset");
    // Check if received "exit"
    this.check_exit();

    return this.buffer;
  }

  /**
   * Exit the program if "exit" received
   */
  private void check_exit(){
    if(this.buffer.equals("exit")) {
    	output.print("Exit...", "red");
    	System.exit(0);
    }
  }

}
