public class Output {

	private final String ANSI_RESET 	= "\u001B[0m";
	private final String ANSI_BLACK 	= "\u001B[30m";
	private final String ANSI_RED 		= "\u001B[31m";
	private final String ANSI_GREEN 	= "\u001B[32m";
	private final String ANSI_YELLOW 	= "\u001B[33m";
	private final String ANSI_BLUE 		= "\u001B[34m";
	private final String ANSI_PURPLE 	= "\u001B[35m";
	private final String ANSI_CYAN 		= "\u001B[36m";
	private final String ANSI_WHITE 	= "\u001B[37m";

  public Output() {
  }

	public void change_color(String color){
		switch(color){
      case "red":
        System.out.print(ANSI_RED);
        break;
      case "green":
        System.out.print(ANSI_GREEN);
        break;
      case "blue":
        System.out.print(ANSI_BLUE);
        break;
			case "cyan":
        System.out.print(ANSI_CYAN);
        break;
      default:
        System.out.print(ANSI_RESET);
        break;
    }
	}

  public void print(String msg){
    System.out.println(msg);
  }

  public void print(String msg, String color){
    switch(color){
      case "red":
        System.out.println(ANSI_RED + msg + ANSI_RESET);
        break;
      case "green":
        System.out.println(ANSI_GREEN + msg + ANSI_RESET);
        break;
      case "blue":
        System.out.println(ANSI_BLUE + msg + ANSI_RESET);
        break;
      default:
        System.out.println(msg);
        break;
    }
  }

  public void printN(String msg){
    System.out.println(msg + "\n");
  }

  public void printN(String msg, String color){
    switch(color){
      case "red":
        System.out.println(ANSI_RED + msg + ANSI_RESET + "\n");
        break;
      case "green":
        System.out.println(ANSI_GREEN + msg + ANSI_RESET + "\n");
        break;
      case "blue":
        System.out.println(ANSI_BLUE + msg + ANSI_RESET + "\n");
        break;
      default:
        System.out.println(msg + "\n");
        break;
    }
  }

  public void section(String msg){
    System.out.println("-----------------------------------------------------------");
    System.out.println(msg + "\n");
  }

  public void error(String error){
    System.out.println(ANSI_RED + "ERROR");
    System.out.println(error + ANSI_RESET + "\n");
  }

  public void error(String[] error){
    System.out.println(ANSI_RED + "ERROR");
    for(String m: error){
      System.out.println(m);
    }
    System.out.println(ANSI_RESET + "\n");
  }

  public void success(){
    System.out.println(ANSI_GREEN + "SUCCESS" + ANSI_RESET + "\n");
  }

  public void success(String msg){
    System.out.println(ANSI_GREEN + "SUCCESS");
    System.out.println(msg + ANSI_RESET + "\n");
  }

}
