import java.net.*;
import java.text.SimpleDateFormat;
import java.io.*;
import org.json.*;

public class Request {

	private static Check check;

	public Request(Check c) {
		this.check = c;
	}

	public String get_city(Location loc) throws Exception {
		int limit = 10;
		int population = 30000;
		int radius = 50;
		String lang = "fr";

		URL url = new URL("http://geodb-free-service.wirefreethought.com/v1/geo/locations/" + loc.get_y() + "+" + loc.get_x() + "/nearbyCities?limit=" + limit +"&offset=0&minPopulation=" + population + "&radius=" + radius + "&languageCode=" + lang + "&sort=-population");

		String result = this.send_request(url);

		return result;
	}

	public String get_location_from_city(String city) throws Exception {
		city = city.replaceAll(" ", "%20");
		URL url = new URL("https://nominatim.openstreetmap.org/search?q=" + city + "&format=json&addressdetails=1");

		String result = this.send_request(url);

		return result;
	}

	public String get_city_from_coord(double lat, double lon) throws Exception {
		URL url = new URL("https://nominatim.openstreetmap.org/reverse?format=json&lat=" + lat + "&lon=" + lon);

		String result = this.send_request(url);

		JSONObject json = new JSONObject(result);

		System.out.println(json);

		return result;
	}

	public String get_path(String from, String to, MyDate date) throws Exception {
		from = from.replaceAll(" ", "%20");
		to = to.replaceAll(" ", "%20");
		SimpleDateFormat parse = new SimpleDateFormat("yyyy-MM-dd");

		URL url = new URL("https://transport.opendata.ch/v1/connections?from=" + from + "&to=" + to + "&date="
				+ parse.format(date.get_date()) + "&time=" + (date.get_t_from().get_hour() + 1) + "%3A"
				+ date.get_t_from().get_min() + "&isArrivalTime=1");

		String result = this.send_request(url);

		return result;
	}

	public String get_path(String from, String to) throws Exception {
		from = from.replaceAll(" ", "%20");
		to = to.replaceAll(" ", "%20");
		SimpleDateFormat parse = new SimpleDateFormat("yyyy-MM-dd");

		URL url = new URL("https://transport.opendata.ch/v1/connections?from=" + from + "&to=" + to + "&date=2019-07-19&time=18%3A00&isArrivalTime=1");

		String result = this.send_request(url);

		return result;
	}

	/**
	 *
	 * @param url
	 * @return
	 * @throws Exception
	 */
	private String send_request(URL url) throws Exception {

		HttpURLConnection con = (HttpURLConnection) url.openConnection();
		con.setRequestMethod("GET");
		con.setRequestProperty("Content-Type", "application/json");

		BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream()));

		String inputLine;
		StringBuilder content = new StringBuilder();

		while ((inputLine = in.readLine()) != null) {
			content.append(inputLine);
		}
		in.close();

		con.disconnect();

		return content.toString();
	}

}
