"use strict"
var db = require('../db/db_request')
var email = require('../email/email')
var config = require('../../config/config.json')

module.exports = {
  choose_appointment: (idMeeting, callback) => {
    choose_date(idMeeting, function(result){

      callback(result)
    })

  }
}

/**
 * [choose_date description]
 * @param  {[type]}   idMeeting [description]
 * @param  {Function} callback  [description]
 * @return {[type]}             [description]
 */
function choose_date(idMeeting, callback){

  db.get_calendar(idMeeting, function(nb_user, calendar){
    //console.log("Nb users:", nb_user);
    //console.log("Calendar : ", calendar);

    var date_table = counting_date(calendar)

    var date, count = 0
    for (var i = 0; i < date_table.length; i++) {

      if(date_table[i].nb > count){
        count = date_table[i].nb

        date = date_table[i].date
        date.time = date_table[i].time
      }
    }
    var percentage = parseInt(count / nb_user  * 100)

    console.log("Date: ", date.day + "/" + date.month + "/" + date.year, "à", date.time.hour + ":" + date.time.minutes, "works for", percentage + "%", "of the people");

    if(percentage < config.appointement.min_perc){


      email.missing_people(idMeeting, date.day + "/" + date.month + "/" + date.year, percentage, nb_user) 
    }


    db.update_appointement(idMeeting, JSON.stringify(date), percentage, function(result){
      callback(date)
    })

  })
}

/**
 * Create a sorted and counted date array
 * @param  {[type]} calendar [description]
 * @return {[type]}          [description]
 */
function counting_date(calendar){
  var count = 0, date_table = [], date

  // counting date and filling date_table
  for (var i = 0; i < calendar.length; i++) {

    // receiving -1 means that's a new date
    var pos = date_exist(calendar[i], date_table)

    if(pos != -1){

      date_table[pos].nb++

      if(date_table[pos].time.hour < calendar[i].from.hour){

        date_table[pos].time.hour = calendar[i].from.hour
        date_table[pos].time.minutes = calendar[i].from.minutes

      } else if(date_table[pos].time.hour == calendar[i].from.hour){

        if(date_table[pos].time.minutes < calendar[i].from.minutes){

          date_table[pos].time.hour = calendar[i].from.hour
          date_table[pos].time.minutes = calendar[i].from.minutes
        }
      }

    } else{
      date_table.push({date: {day: calendar[i].day, month: calendar[i].month, year: calendar[i].year}, time: calendar[i].from, nb: 1})
    }
  }

  return date_table
}

/**
 * Check if date exist in array
 * @param  {[type]} date  [description]
 * @param  {[type]} table [description]
 * @return {[type]}       [description]
 */
function date_exist(date, table){
  for (var i = 0; i < table.length; i++) {

    if(date.day === table[i].date.day && date.month === table[i].date.month && date.year === table[i].date.year){
      return i
    }
  }

  return -1
}
