"use strict"

var http = require('../api/http_request')
var db = require('./db/db_request')

var appointement = require('./appointement/appointement')
var journey = require('./journey/journey')
var user = require('./user/user')
var search = require('./appointement/search_cities')
var hash = require('./hash/hash')
var email = require('./email/email')

module.exports = {
  create_meeting: (data, callback) => {

    // !!! validate data !!!

    hash.generate_id(data, function(id){

      console.log("Id received:", id);

      db.create_meeting(id, JSON.stringify(data), function(result){
        console.log(result);

        email.new_meeting(data.email, id)

        callback(id)
      })
    })

  },

  remove_meeting: (callback) => {

  },

  add_user: (idMeeting, data, callback) => {
    user.add_user(idMeeting, data, function(result){

      appointement.choose_appointment(idMeeting, function(r){

        journey.update_center(idMeeting, function(res){

          journey.update_journeys(idMeeting, function(c){

            email.new_member(idMeeting, data)

            callback(res)
          })
        })
      })
    })
  },

  update_user: (idMeeting, idUser, data, callback) => {
    user.update_user(idMeeting, idUser, data, function(result){

      appointement.choose_appointment(idMeeting, function(r){

        journey.update_center(idMeeting, function(res){

          journey.update_journeys(idMeeting, function(c){

            email.new_member(idMeeting, data)

            callback(res)
          })
        })
      })
    })
  },

  remove_user: (idMeeting, idUser, callback) => {
    db.remove_user(idMeeting, idUser, function(){

      db.count_users(idMeeting, function(nb_user){

        // if there are still users
        if(nb_user > 0){
          appointement.choose_appointment(idMeeting, function(){

            journey.update_center(idMeeting, function(){

              journey.update_journeys(idMeeting, function(){

                callback()

              })
            })
          })

        }else {
          db.reset_meeting(idMeeting, function(){

            callback()
          })
        }
      })

    })
  },

  load_cities: () => {
    var point = {lat: 46.97370385000001, lon: 7.67067955}

    http.get_cities(point).then(function(res){
      console.log(res);
    })

  },

  update_journeys: () => {
    journey.update_journeys(0, function(){
      console.log("callback ended");
    })
  }

}
