var socket = require('socket.io')

var db = require('../class/db/db_request')
var http = require('../api/http_request')

// ---- temp ----
var journey = require('../class/journey/journey')
var appointement = require('../class/appointement/appointement')
var meetus = require('../class/meetus')
var hash = require('../class/hash/hash')
var email = require('../class/email/email')

var config = require('../config/config.json')

module.exports = function(server){
  var io = socket(server)

  io.on('connection', function(socket){
    console.log('SOCKET: A connection has been made')
    console.log('SOCKET: The socket is', socket.id)

    socket.on('get_meeting', function(idMeeting){
      get_meeting(idMeeting)
    })

    socket.on('get_user', function(idMeeting, idUser){

      db.get_user(idMeeting, idUser, function(user){
        socket.emit('get_user', user)
      })

    })

    socket.on('create_meeting', function(data){
      meetus.create_meeting(data, function(idMeeting){
        socket.emit('create_meeting', idMeeting)
      })
    })

    socket.on('add_user', function(idMeeting, data){
      meetus.add_user(idMeeting, data, function(){
        get_meeting(idMeeting)
      })

    })

    socket.on('update_user', function(idMeeting, idUser, data){

      console.log("Je modifie:", idMeeting, idUser, data);


      meetus.update_user(idMeeting, idUser, data, function(){
        get_meeting(idMeeting)
      })
    })

    socket.on('remove_user', function(idMeeting, idUser){
      meetus.remove_user(idMeeting, idUser, function(){
        get_meeting(idMeeting)
      })
    })

    socket.on('check_id', function(id){
      db.check_id(id, function(result){
        socket.emit('check_id', result)
      })
    })

    socket.on('find_city', function(name){

    })




    // -------- TEMP -----------------
    socket.on('update_center', function(idMeeting){
      journey.update_center(idMeeting, function(result){
        get_meeting(idMeeting)
      })
    })

    socket.on('update_appointement', function(id){
      appointement.choose_appointment(id, function(res){
        get_meeting('get_meeting', id)
      })
    })

    socket.on('update_journeys', function(id){
      journey.update_journeys(id, function(res){
        get_meeting('get_meeting', id)
      })
    })

    socket.on('test_class', function(idMeeting){
      //meetus.load_cities()
      //meetus.update_journeys()
      //hash.generate_id()
      console.log("Socket email:", idMeeting);
      email.new_meeting("vachon.marc@outlook.com", idMeeting)
    })





    function get_meeting(idMeeting){
      db.get_meeting(idMeeting, function(data){
        socket.emit('get_meeting', data)
      })
    }


  })
}
