
var meeting_data

$(document).ready(function(){
  socket.emit('get_meeting', id_meeting)

  $("#add_date").click(function(){
    var name = $("#name").val();
    var email = $("#email").val();
    var markup = "<tr><td><input type='checkbox' name='record'></td>" +
    "<td class='duration px-1'>" +
    "<input type='number' class='form-control' name='day' placeholder='day'>" +
    "<input type='number' class='form-control' name='month' placeholder='month'>" +
    "<input type='number' class='form-control' name='year' placeholder='year'>" +
    "</td>" +
    "<td class='duration px-1'>" +
    "<p>From</p>" +
    "<input type='number' class='form-control d-inline' name='from_hour' placeholder='hour'>" +
    "<p class='d-inline'>:</p>" +
    "<input type='number' class='form-control d-inline-block' name='from_minutes' placeholder='minutes'>" +

    "<p>to</p>" +
    "<input type='number' class='form-control d-inline' name='to_hour' placeholder='hour'>" +
    "<p class='d-inline'>:</p>" +
    "<input type='number' class='form-control d-inline-block' name='to_minutes' placeholder='minutes'>" +
    "</td></tr>";
    $("table tbody").append(markup);
  });

  // Find and remove selected table rows
  $("#remove_date").click(function(){
    $("table tbody").find('input[name="record"]').each(function(){
      if($(this).is(":checked")){
        $(this).parents("tr").remove();
      }
    });
  });
})



socket.on('get_meeting', function(data){

  $('#users').html('')

  const parameters = `


  <div class="card mb-5 w-100 mx-3">
  <div class="card-body">

  <div class="row">

  <div class="col-md-3">
  <h2 class="font-weight-bold mb-3 d-inline">Code: </h2>
  </div>

  <div class="col-md-9 text-md-right" style="word-wrap: break-word;">
  <h4 class="d-inline font-weight-bold"><small>${id_meeting}</small></h4>
  </div>

  <p class="text-muted mx-3 mt-4 text-right">Ce code correspond à ce rendez-vous. Partagez-le avec les personnes concernées.</p>

  </div>

  </div>
  </div>



  <div class="col-md-6">
  <h2 class="font-weight-bold mb-3">Paramètres généraux</h2>

  <div class="card mb-5">
  <div class="card-body">

  <dl class="row my-1 mx-md-2">
  <dt class="col-sm-3">Nom</dt>
  <dd class="col-sm-9">${data.name}</dd>

  <dt class="col-sm-3">Créateur</dt>
  <dd class="col-sm-9">${data.creator}</dd>

  <dt class="col-sm-3">Périodes</dt>
  <dd class="col-sm-9">Du ${data.period.date_from.day}/${data.period.date_from.month}/${data.period.date_from.year} au ${data.period.date_to.day}/${data.period.date_to.month}/${data.period.date_to.year}</dd>

  </dl>

  </div>
  </div>

  </div>

  <div class="col-md-6">



  <h2 class="font-weight-bold mb-3">Rendez-vous</h2>

  <div class="card mb-5">
  <div class="card-body">

  <dl class="row my-1 mx-md-2">
  <dt class="col-sm-3">Date</dt>
  <dd class="col-sm-9">
  ${data.date  ? `Le ${data.date.day}/${data.date.month}/${data.date.year} à ${data.date.time.hour}:${data.date.time.minutes}` : ''}
  </dd>

  <dt class="col-sm-3">Works for</dt>
  <dd class="col-sm-9">
  ${data.percentage ? `${data.percentage}%` : ''}
  </dd>

  <dt class="col-sm-3">Lieux</dt>
  <dd class="col-sm-9">
  ${data.location ? data.location : ''}
  </dd>
  </dl>

  </div>
  </div>

  </div>
  `
  $('#parameters').html(parameters)

  for (var i = 0; i < data.user_table.length; i++) {
    var user = data.user_table[i]

    const markup = `
    <div class="col-md-6 mb-3">

    <div class="card">
    <div class="card-header">

    <h5 class="card-subtitle d-inline-block">${user.name}</h5>

    <div class="d-inline-block">
      <button class="btn btn-warning" type="button" name="button" onclick="toggle_modify_user(${i})">Modify</button>
      <button class="btn btn-danger" type="button" name="button" onclick="remove_user(${i})">delete</button>
      <button type="button" class="btn btn-outline-primary" onclick="toggle_user_info( ${i})" id="show_more">Afficher plus</button>
    </div>

    <h6 class="card-subtitle font-weight-normal">${user.email}</h6>

    </div>

    <div class="card-body px-4 py-3 d-none" id="user-${i}">


    <div class="row">
    <div class="col-xl-3">

    <h5 class="card-subtitle">Address</h5>
    <p>${user.address}</p>

    </div>

    <div class="col-xl-9">

    <h5 class="card-subtitle">Calendar</h5>
    <ul class="list-unstyled">
    ${user.calendar.map(date => `<li>${date.day}/${date.month}/${date.year} from: ${date.from.hour}:${date.from.minutes} to: ${date.to.hour}:${date.to.minutes}</li>`)}
    </ul>

    </div>
    </div>

    <h5 class="card-subtitle">Journey</h5>
    <h6><small>Duration: ${user.journey.time.hour}h${user.journey.time.minutes}</small></h6>
    <table class="table text-main">
    <tr>
    <th>Time</th>
    <th>Journey</th>
    <th>Platform</th>
    </tr>
    ${user.journey.steps.map(step => `<tr>
      <td>${step.from.hour}:${step.from.minutes}<br /><br />${step.to.hour}:${step.to.minutes}</td>
      <td>${step.from.station}<br />${step.transport}<br />${step.to.station}</td>
      <td>${step.from.platform}<br /><br />${step.to.platform}</td>
      </tr>`)}
      </table>

      </div>
      </div>


      </div>
      `

      $('#users').append(markup);
    }
  })


  function update_center(){
    socket.emit('update_center', id_meeting)
  }

  function update_journeys(){
    socket.emit('update_journeys', id_meeting)
  }

  function update_appointement(){
    socket.emit('update_appointement', id_meeting)
  }

  function toggle_user(){
    $('#user').toggleClass('d-none d-flex');
  }

  function toggle_modify_user(idUser){
    socket.emit('get_user', id_meeting, idUser)

    socket.on('get_user', function(data){
      $('#name').val(data.name)
      $('#email').val(data.email)
      $('#city').val(data.address)

      toggle_user()
    })

  }

  function toggle_user_info(id){
    $('#user-' + id).toggleClass('d-none d-block');
  }

  function add_user(){
    var user = {
      name: $('#name').val(),
      email: $('#email').val(),
      address: $('#city').val(),
      calendar: create_calendar(),
      journey: {}
    }

    socket.emit('add_user', id_meeting, user)

    toggle_user()
  }

  function update_user(idUser){
    console.log('jupdate');
    var user = {
      name: $('#name').val(),
      email: $('#email').val(),
      address: $('#city').val(),
      calendar: create_calendar(),
      journey: {}
    }

    socket.emit('update_user', id_meeting, idUser, user)

    toggle_user()
  }

  function remove_user(idUser){
    if(confirm("Voulez-vous vraiment supprimer cet utilsiateur ?")){
      socket.emit('remove_user', id_meeting, idUser);
    }

  }

  function create_calendar(){
    var calendar = []

    $('.user-calendar tbody tr').each(function(i){

      calendar.push({
        day: parseInt($(this).find('.form-control[name=day]').val()),
        month: parseInt($(this).find('.form-control[name=month]').val()),
        year: parseInt($(this).find('.form-control[name=year]').val()),
        from:{
          hour: parseInt($(this).find('.form-control[name=from_hour]').val()),
          minutes: parseInt($(this).find('.form-control[name=from_minutes]').val())
        },
        to:{
          hour: parseInt($(this).find('.form-control[name=to_hour]').val()),
          minutes: parseInt($(this).find('.form-control[name=to_minutes]').val())
        }
      });

    })

    console.log(calendar);

    return calendar
  }
